/***************************************************************************
 *   Copyright (C) 2009 by Rene Landert <rene.landert@bluewin.ch>          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/


#define consumption_filename_part1 "/var/opt/kchildlock/.kch_time_"
#define consumption_filename_part3 ".tmp"

#include <qstring.h>
#include <qfile.h>
//#include "../common/kchildlockcommon.h"


class Consumption
{
public:
   Consumption();
   ~Consumption();

private:
   QString consumption_filename;
   QFile *consumption_file;

   QString version;
   int weekofyear;
   int dayofweek;
   QString username;

public:
   int pcusage_daily;
   int pcusage_weekly;
   QString appname1, appname2, appname3;
   int app1usage_daily, app1usage_weekly;
   int app2usage_daily, app2usage_weekly;
   int app3usage_daily, app3usage_weekly;
    
public:
   bool open(QString);
   void read();
   void write();
   void close();
   void set_default_values(QString);
   void reset_daily_values();
   QString get_consumption_filename();
   int get_weekofyear();
   int get_dayofweek();

};
