/***************************************************************************
 *   Copyright (C) 2009 by Rene Landert <rene.landert@bluewin.ch>          *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <KConfigDialog>

#include "KchildlockKCM.h"
#include "kchildlock_general.h"
#include "kchildlock_user.h"
#include "kchildlock_group.h"




void KchildlockKCM::connect_general(Ui_generalPage *general_ui)
{
// connections for general page
    connect(general_ui->kcfg_scaninterval, SIGNAL(valueChanged(int)), SLOT(emitChanged_scaninterval(int)));
    connect(general_ui->kcfg_enable_restrictions, SIGNAL(stateChanged(int)), SLOT(emitChanged_enable_restrictions(int)));
    connect(general_ui->kcfg_enable_systray, SIGNAL(stateChanged(int)), SLOT(emitChanged_enable_systray(int)));
}


void KchildlockKCM::connect_user(Ui_userPage *user_ui)
{
//connections for user page
    connect(user_ui->kcfg_enabled, SIGNAL(stateChanged(int)), SLOT(emitChanged_enabled_user(int)));
    connect(user_ui->kcfg_username, SIGNAL(activated(QString)), SLOT(emitChanged_username_user(QString)));
    connect(user_ui->kcfg_sameRestrict, SIGNAL(toggled(bool)), SLOT(emitChanged_sameRestrict_user(bool)));
    connect(user_ui->kcfg_diffRestrict, SIGNAL(toggled(bool)), SLOT(emitChanged_diffRestrict_user(bool)));

    connect(user_ui->kcfg_DAYfrom, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_DAYto, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_DAYmaxhr, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_DAYmaxmin, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));

    connect(user_ui->kcfg_MONenabled, SIGNAL(stateChanged(int)), SLOT(emitChanged_MONenabled_user(int)));
    connect(user_ui->kcfg_MONfrom, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_MONto, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_MONmaxhr, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_MONmaxmin, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));

    connect(user_ui->kcfg_TUEenabled, SIGNAL(stateChanged(int)), SLOT(emitChanged_TUEenabled_user(int)));
    connect(user_ui->kcfg_TUEfrom, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_TUEto, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_TUEmaxhr, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_TUEmaxmin, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));

    connect(user_ui->kcfg_WEDenabled, SIGNAL(stateChanged(int)), SLOT(emitChanged_WEDenabled_user(int)));
    connect(user_ui->kcfg_WEDfrom, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_WEDto, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_WEDmaxhr, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_WEDmaxmin, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));

    connect(user_ui->kcfg_THUenabled, SIGNAL(stateChanged(int)), SLOT(emitChanged_THUenabled_user(int)));
    connect(user_ui->kcfg_THUfrom, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_THUto, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_THUmaxhr, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_THUmaxmin, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));

    connect(user_ui->kcfg_FRIenabled, SIGNAL(stateChanged(int)), SLOT(emitChanged_FRIenabled_user(int)));
    connect(user_ui->kcfg_FRIfrom, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_FRIto, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_FRImaxhr, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_FRImaxmin, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));

    connect(user_ui->kcfg_SATenabled, SIGNAL(stateChanged(int)), SLOT(emitChanged_SATenabled_user(int)));
    connect(user_ui->kcfg_SATfrom, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_SATto, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_SATmaxhr, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_SATmaxmin, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));

    connect(user_ui->kcfg_SUNenabled, SIGNAL(stateChanged(int)), SLOT(emitChanged_SUNenabled_user(int)));
    connect(user_ui->kcfg_SUNfrom, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_SUNto, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_SUNmaxhr, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_SUNmaxmin, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));

    connect(user_ui->kcfg_WEEKenabled, SIGNAL(stateChanged(int)), SLOT(emitChanged_WEEKenabled_user(int)));
    connect(user_ui->kcfg_WEEKmaxhr, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_WEEKmaxmin, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));

    connect(user_ui->kcfg_APP1enabled, SIGNAL(stateChanged(int)), SLOT(emitChanged_APPenabled_user(int)));
    connect(user_ui->kcfg_AppName1, SIGNAL(textChanged(QString)), SLOT(emitChanged_appname_user(QString)));
    connect(user_ui->kcfg_App1from, SIGNAL(timeChanged(QTime)), SLOT(emitChanged_time_user(QTime)));
    connect(user_ui->kcfg_App1to, SIGNAL(timeChanged(QTime)), SLOT(emitChanged_time_user(QTime)));
    connect(user_ui->kcfg_App1maxDhr, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_App1maxDmin, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_App1maxWhr, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_App1maxWmin, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));

    connect(user_ui->kcfg_APP2enabled, SIGNAL(stateChanged(int)), SLOT(emitChanged_APPenabled_user(int)));
    connect(user_ui->kcfg_AppName2, SIGNAL(textChanged(QString)), SLOT(emitChanged_appname_user(QString)));
    connect(user_ui->kcfg_App2from, SIGNAL(timeChanged(QTime)), SLOT(emitChanged_time_user(QTime)));
    connect(user_ui->kcfg_App2to, SIGNAL(timeChanged(QTime)), SLOT(emitChanged_time_user(QTime)));
    connect(user_ui->kcfg_App2maxDhr, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_App2maxDmin, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_App2maxWhr, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_App2maxWmin, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));

    connect(user_ui->kcfg_APP3enabled, SIGNAL(stateChanged(int)), SLOT(emitChanged_APPenabled_user(int)));
    connect(user_ui->kcfg_AppName3, SIGNAL(textChanged(QString)), SLOT(emitChanged_appname_user(QString)));
    connect(user_ui->kcfg_App3from, SIGNAL(timeChanged(QTime)), SLOT(emitChanged_time_user(QTime)));
    connect(user_ui->kcfg_App3to, SIGNAL(timeChanged(QTime)), SLOT(emitChanged_time_user(QTime)));
    connect(user_ui->kcfg_App3maxDhr, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_App3maxDmin, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_App3maxWhr, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));
    connect(user_ui->kcfg_App3maxWmin, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_user(int)));

}



void KchildlockKCM::connect_group(Ui_groupPage *group_ui)
{
//connections for group1 page
    connect(group_ui->kcfg_enabled, SIGNAL(stateChanged(int)), SLOT(emitChanged_enabled_group(int)));
    connect(group_ui->kcfg_groupname, SIGNAL(activated(QString)), SLOT(emitChanged_groupname_group(QString)));
    connect(group_ui->kcfg_sameRestrict, SIGNAL(toggled(bool)), SLOT(emitChanged_sameRestrict_group(bool)));
    connect(group_ui->kcfg_diffRestrict, SIGNAL(toggled(bool)), SLOT(emitChanged_diffRestrict_group(bool)));

    connect(group_ui->kcfg_DAYfrom, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));
    connect(group_ui->kcfg_DAYto, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));
    connect(group_ui->kcfg_DAYmaxhr, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));
    connect(group_ui->kcfg_DAYmaxmin, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));

    connect(group_ui->kcfg_MONenabled, SIGNAL(stateChanged(int)), SLOT(emitChanged_MONenabled_group(int)));
    connect(group_ui->kcfg_MONfrom, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));
    connect(group_ui->kcfg_MONto, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));
    connect(group_ui->kcfg_MONmaxhr, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));
    connect(group_ui->kcfg_MONmaxmin, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));

    connect(group_ui->kcfg_TUEenabled, SIGNAL(stateChanged(int)), SLOT(emitChanged_TUEenabled_group(int)));
    connect(group_ui->kcfg_TUEfrom, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));
    connect(group_ui->kcfg_TUEto, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));
    connect(group_ui->kcfg_TUEmaxhr, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));
    connect(group_ui->kcfg_TUEmaxmin, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));

    connect(group_ui->kcfg_WEDenabled, SIGNAL(stateChanged(int)), SLOT(emitChanged_WEDenabled_group(int)));
    connect(group_ui->kcfg_WEDfrom, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));
    connect(group_ui->kcfg_WEDto, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));
    connect(group_ui->kcfg_WEDmaxhr, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));
    connect(group_ui->kcfg_WEDmaxmin, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));

    connect(group_ui->kcfg_THUenabled, SIGNAL(stateChanged(int)), SLOT(emitChanged_THUenabled_group(int)));
    connect(group_ui->kcfg_THUfrom, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));
    connect(group_ui->kcfg_THUto, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));
    connect(group_ui->kcfg_THUmaxhr, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));
    connect(group_ui->kcfg_THUmaxmin, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));

    connect(group_ui->kcfg_FRIenabled, SIGNAL(stateChanged(int)), SLOT(emitChanged_FRIenabled_group(int)));
    connect(group_ui->kcfg_FRIfrom, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));
    connect(group_ui->kcfg_FRIto, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));
    connect(group_ui->kcfg_FRImaxhr, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));
    connect(group_ui->kcfg_FRImaxmin, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));

    connect(group_ui->kcfg_SATenabled, SIGNAL(stateChanged(int)), SLOT(emitChanged_SATenabled_group(int)));
    connect(group_ui->kcfg_SATfrom, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));
    connect(group_ui->kcfg_SATto, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));
    connect(group_ui->kcfg_SATmaxhr, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));
    connect(group_ui->kcfg_SATmaxmin, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));

    connect(group_ui->kcfg_SUNenabled, SIGNAL(stateChanged(int)), SLOT(emitChanged_SUNenabled_group(int)));
    connect(group_ui->kcfg_SUNfrom, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));
    connect(group_ui->kcfg_SUNto, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));
    connect(group_ui->kcfg_SUNmaxhr, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));
    connect(group_ui->kcfg_SUNmaxmin, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));

    connect(group_ui->kcfg_WEEKenabled, SIGNAL(stateChanged(int)), SLOT(emitChanged_WEEKenabled_group(int)));
    connect(group_ui->kcfg_WEEKmaxhr, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));
    connect(group_ui->kcfg_WEEKmaxmin, SIGNAL(valueChanged(int)), SLOT(emitChanged_value_group(int)));
}
