/***************************************************************************
 *   Copyright (C) 2010 by Rene Landert <rene.landert@bluewin.ch>          *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "KchildlockKCM.h"
#include "kchildlock_general.h"
#include "kchildlock_user.h"
#include "kchildlock_group.h"

#include "ui_userPage.h"
#include "ui_groupPage.h"
#include "ui_generalPage.h"




void KchildlockKCM::fillValuesInGui_general()
{

   general->kcfg_enable_restrictions->setChecked(myGeneralSettings->enable_restrictions());
   general->kcfg_enable_systray->setChecked(myGeneralSettings->enable_systray());
   general->kcfg_scaninterval->setValue(myGeneralSettings->scaninterval());
}

void KchildlockKCM::fillValuesInGui_user(Ui_userPage *user, KchildlockUserSettings *mySettings)
{
  
   user->kcfg_enabled->setChecked(mySettings->enabled());
   user->kcfg_sameRestrict->setChecked(mySettings->sameRestrict());
   user->kcfg_diffRestrict->setChecked(mySettings->diffRestrict());

   user->kcfg_DAYfrom->setValue(mySettings->dAYfrom());
   user->kcfg_DAYto->setValue(mySettings->dAYto());
   user->kcfg_DAYmaxhr->setValue(mySettings->dAYmaxhr());
   user->kcfg_DAYmaxmin->setValue(mySettings->dAYmaxmin());

   user->kcfg_MONenabled->setChecked(mySettings->mONenabled());
   user->kcfg_MONfrom->setValue(mySettings->mONfrom());
   user->kcfg_MONto->setValue(mySettings->mONto());
   user->kcfg_MONmaxhr->setValue(mySettings->mONmaxhr());
   user->kcfg_MONmaxmin->setValue(mySettings->mONmaxmin());

   user->kcfg_TUEenabled->setChecked(mySettings->tUEenabled());
   user->kcfg_TUEfrom->setValue(mySettings->tUEfrom());
   user->kcfg_TUEto->setValue(mySettings->tUEto());
   user->kcfg_TUEmaxhr->setValue(mySettings->tUEmaxhr());
   user->kcfg_TUEmaxmin->setValue(mySettings->tUEmaxmin());

   user->kcfg_WEDenabled->setChecked(mySettings->wEDenabled());
   user->kcfg_WEDfrom->setValue(mySettings->wEDfrom());
   user->kcfg_WEDto->setValue(mySettings->wEDto());
   user->kcfg_WEDmaxhr->setValue(mySettings->wEDmaxhr());
   user->kcfg_WEDmaxmin->setValue(mySettings->wEDmaxmin());

   user->kcfg_THUenabled->setChecked(mySettings->tHUenabled());
   user->kcfg_THUfrom->setValue(mySettings->tHUfrom());
   user->kcfg_THUto->setValue(mySettings->tHUto());
   user->kcfg_THUmaxhr->setValue(mySettings->tHUmaxhr());
   user->kcfg_THUmaxmin->setValue(mySettings->tHUmaxmin());

   user->kcfg_FRIenabled->setChecked(mySettings->fRIenabled());
   user->kcfg_FRIfrom->setValue(mySettings->fRIfrom());
   user->kcfg_FRIto->setValue(mySettings->fRIto());
   user->kcfg_FRImaxhr->setValue(mySettings->fRImaxhr());
   user->kcfg_FRImaxmin->setValue(mySettings->fRImaxmin());

   user->kcfg_SATenabled->setChecked(mySettings->sATenabled());
   user->kcfg_SATfrom->setValue(mySettings->sATfrom());
   user->kcfg_SATto->setValue(mySettings->sATto());
   user->kcfg_SATmaxhr->setValue(mySettings->sATmaxhr());
   user->kcfg_SATmaxmin->setValue(mySettings->sATmaxmin());

   user->kcfg_SUNenabled->setChecked(mySettings->sUNenabled());
   user->kcfg_SUNfrom->setValue(mySettings->sUNfrom());
   user->kcfg_SUNto->setValue(mySettings->sUNto());
   user->kcfg_SUNmaxhr->setValue(mySettings->sUNmaxhr());
   user->kcfg_SUNmaxmin->setValue(mySettings->sUNmaxmin());

   user->kcfg_WEEKenabled->setChecked(mySettings->wEEKenabled());
   user->kcfg_WEEKmaxhr->setValue(mySettings->wEEKmaxhr());
   user->kcfg_WEEKmaxmin->setValue(mySettings->wEEKmaxmin());

   user->kcfg_AppName1->setText(mySettings->appName1());
   user->kcfg_App1from->setValue(mySettings->app1from());
   user->kcfg_App1to->setValue(mySettings->app1to());
   user->kcfg_App1maxDhr->setValue(mySettings->app1maxDhr());
   user->kcfg_App1maxDmin->setValue(mySettings->app1maxDmin());
   user->kcfg_App1maxWhr->setValue(mySettings->app1maxWhr());
   user->kcfg_App1maxWmin->setValue(mySettings->app1maxWmin());

   user->kcfg_AppName2->setText(mySettings->appName2());
   user->kcfg_App2from->setValue(mySettings->app2from());
   user->kcfg_App2to->setValue(mySettings->app2to());
   user->kcfg_App2maxDhr->setValue(mySettings->app2maxDhr());
   user->kcfg_App2maxDmin->setValue(mySettings->app2maxDmin());
   user->kcfg_App2maxWhr->setValue(mySettings->app2maxWhr());
   user->kcfg_App2maxWmin->setValue(mySettings->app2maxWmin());

   user->kcfg_AppName3->setText(mySettings->appName3());
   user->kcfg_App3from->setValue(mySettings->app3from());
   user->kcfg_App3to->setValue(mySettings->app3to());
   user->kcfg_App3maxDhr->setValue(mySettings->app3maxDhr());
   user->kcfg_App3maxDmin->setValue(mySettings->app3maxDmin());
   user->kcfg_App3maxWhr->setValue(mySettings->app3maxWhr());
   user->kcfg_App3maxWmin->setValue(mySettings->app3maxWmin());
   
// check for same restrictions every day / enabled
   if (mySettings->enabled()) {
     if (mySettings->sameRestrict())  {
        KchildlockKCM::disableDifferentSettings_user(user);
     } else {
        KchildlockKCM::disableSameSettings_user(user);
     };
     if (mySettings->wEEKenabled()) {
       KchildlockKCM::setupUi_WEEK_user(FALSE, TRUE, user);
     } else {
       KchildlockKCM::setupUi_WEEK_user(FALSE, FALSE, user);
     }
     if (mySettings->aPP1enabled()) {
       user->kcfg_APP1enabled->setChecked(TRUE);
       KchildlockKCM::setupUi_APP1_user(FALSE, TRUE, user);
     } else {
       user->kcfg_APP1enabled->setChecked(FALSE);
       KchildlockKCM::setupUi_APP1_user(FALSE, FALSE, user);
     }
     if (mySettings->aPP2enabled()) {
       user->kcfg_APP2enabled->setChecked(TRUE);
       KchildlockKCM::setupUi_APP2_user(FALSE, TRUE, user);
     } else {
       user->kcfg_APP2enabled->setChecked(FALSE);
       KchildlockKCM::setupUi_APP2_user(FALSE, FALSE, user);
     }
     if (mySettings->aPP3enabled()) {
       user->kcfg_APP3enabled->setChecked(TRUE);
       KchildlockKCM::setupUi_APP3_user(FALSE, TRUE, user);
     } else {
       user->kcfg_APP3enabled->setChecked(FALSE);
       KchildlockKCM::setupUi_APP3_user(FALSE, FALSE, user);
     }
     user->kcfg_APP1enabled->setDisabled(FALSE);
     user->kcfg_APP2enabled->setDisabled(FALSE);
     user->kcfg_APP3enabled->setDisabled(FALSE);

   } else {
        KchildlockKCM::disableSameSettings_user(user);
        KchildlockKCM::disableDifferentSettings_user(user);
        KchildlockKCM::setupUi_DAY_user(TRUE, FALSE, user);
        user->kcfg_sameRestrict->setDisabled(TRUE);
        user->kcfg_diffRestrict->setDisabled(TRUE);
        KchildlockKCM::setupUi_WEEK_user(TRUE, FALSE, user);
        KchildlockKCM::setupUi_APP1_user(TRUE, FALSE, user);
        KchildlockKCM::setupUi_APP2_user(TRUE, FALSE, user);
        KchildlockKCM::setupUi_APP3_user(TRUE, FALSE, user);
        user->kcfg_APP1enabled->setDisabled(TRUE);
        user->kcfg_APP2enabled->setDisabled(TRUE);
        user->kcfg_APP3enabled->setDisabled(TRUE);

     if (mySettings->aPP1enabled()) {
       user->kcfg_APP1enabled->setChecked(TRUE);
     } else {
       user->kcfg_APP1enabled->setChecked(FALSE);
     }
     if (mySettings->aPP2enabled()) {
       user->kcfg_APP2enabled->setChecked(TRUE);
     } else {
       user->kcfg_APP2enabled->setChecked(FALSE);
     }
     if (mySettings->aPP3enabled()) {
       user->kcfg_APP3enabled->setChecked(TRUE);
     } else {
       user->kcfg_APP3enabled->setChecked(FALSE);
     }
   }
   emit changed(true);
}


void KchildlockKCM::fillValuesInGui_group(Ui_groupPage *group, KchildlockGroupSettings *mySettings)
{
  
   group->kcfg_enabled->setChecked(mySettings->enabled());
   group->kcfg_sameRestrict->setChecked(mySettings->sameRestrict());
   group->kcfg_diffRestrict->setChecked(mySettings->diffRestrict());
   group->kcfg_DAYfrom->setValue(mySettings->dAYfrom());
   group->kcfg_DAYto->setValue(mySettings->dAYto());
   group->kcfg_DAYmaxhr->setValue(mySettings->dAYmaxhr());
   group->kcfg_DAYmaxmin->setValue(mySettings->dAYmaxmin());

   group->kcfg_MONenabled->setChecked(mySettings->mONenabled());
   group->kcfg_MONfrom->setValue(mySettings->mONfrom());
   group->kcfg_MONto->setValue(mySettings->mONto());
   group->kcfg_MONmaxhr->setValue(mySettings->mONmaxhr());
   group->kcfg_MONmaxmin->setValue(mySettings->mONmaxmin());

   group->kcfg_TUEenabled->setChecked(mySettings->tUEenabled());
   group->kcfg_TUEfrom->setValue(mySettings->tUEfrom());
   group->kcfg_TUEto->setValue(mySettings->tUEto());
   group->kcfg_TUEmaxhr->setValue(mySettings->tUEmaxhr());
   group->kcfg_TUEmaxmin->setValue(mySettings->tUEmaxmin());

   group->kcfg_WEDenabled->setChecked(mySettings->wEDenabled());
   group->kcfg_WEDfrom->setValue(mySettings->wEDfrom());
   group->kcfg_WEDto->setValue(mySettings->wEDto());
   group->kcfg_WEDmaxhr->setValue(mySettings->wEDmaxhr());
   group->kcfg_WEDmaxmin->setValue(mySettings->wEDmaxmin());

   group->kcfg_THUenabled->setChecked(mySettings->tHUenabled());
   group->kcfg_THUfrom->setValue(mySettings->tHUfrom());
   group->kcfg_THUto->setValue(mySettings->tHUto());
   group->kcfg_THUmaxhr->setValue(mySettings->tHUmaxhr());
   group->kcfg_THUmaxmin->setValue(mySettings->tHUmaxmin());

   group->kcfg_FRIenabled->setChecked(mySettings->fRIenabled());
   group->kcfg_FRIfrom->setValue(mySettings->fRIfrom());
   group->kcfg_FRIto->setValue(mySettings->fRIto());
   group->kcfg_FRImaxhr->setValue(mySettings->fRImaxhr());
   group->kcfg_FRImaxmin->setValue(mySettings->fRImaxmin());

   group->kcfg_SATenabled->setChecked(mySettings->sATenabled());
   group->kcfg_SATfrom->setValue(mySettings->sATfrom());
   group->kcfg_SATto->setValue(mySettings->sATto());
   group->kcfg_SATmaxhr->setValue(mySettings->sATmaxhr());
   group->kcfg_SATmaxmin->setValue(mySettings->sATmaxmin());

   group->kcfg_SUNenabled->setChecked(mySettings->sUNenabled());
   group->kcfg_SUNfrom->setValue(mySettings->sUNfrom());
   group->kcfg_SUNto->setValue(mySettings->sUNto());
   group->kcfg_SUNmaxhr->setValue(mySettings->sUNmaxhr());
   group->kcfg_SUNmaxmin->setValue(mySettings->sUNmaxmin());

   group->kcfg_WEEKenabled->setChecked(mySettings->wEEKenabled());
   group->kcfg_WEEKmaxhr->setValue(mySettings->wEEKmaxhr());
   group->kcfg_WEEKmaxmin->setValue(mySettings->wEEKmaxmin());

// check for same restrictions every day
   if (mySettings->enabled()) {
     if (mySettings->sameRestrict())  {
       KchildlockKCM::disableDifferentSettings_group(group);
     }  else {
       KchildlockKCM::disableSameSettings_group(group);
     };
     if (mySettings->wEEKenabled()) {
       KchildlockKCM::setupUi_WEEK_group(FALSE, TRUE, group);
     } else {
       KchildlockKCM::setupUi_WEEK_group(FALSE, FALSE, group);
     }
   } else {
        KchildlockKCM::disableSameSettings_group(group);
        KchildlockKCM::disableDifferentSettings_group(group);
        KchildlockKCM::setupUi_DAY_group(TRUE, FALSE, group);
        group->kcfg_sameRestrict->setDisabled(TRUE);
        group->kcfg_diffRestrict->setDisabled(TRUE);
        KchildlockKCM::setupUi_WEEK_group(TRUE, FALSE, group);
   }
   emit changed(true);

}
