/***************************************************************************
 *   Copyright (C) 2009 by Rene Landert <rene.landert@bluewin.ch>          *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <KConfigDialog>


#include "KchildlockKCM.h"
#include "kchildlock_group.h"


// Group1...3 Slots ===========================================================================

void KchildlockKCM::emitChanged_enabled_group(int value)
{
   Ui_groupPage *group_ui = KchildlockKCM::current_groupPage();
   if (group_ui == 0) return;
   mycurrent_GroupSettings->setEnabled(value);
   if (value) {
     if (group_ui->kcfg_sameRestrict->isChecked())  {
        group_ui->kcfg_sameRestrict->setDisabled(FALSE);
        group_ui->kcfg_diffRestrict->setDisabled(FALSE);
        KchildlockKCM::disableDifferentSettings_group(group_ui);
        KchildlockKCM::setupUi_DAY_group(FALSE, TRUE, group_ui);
        KchildlockKCM::setupUi_MON_group(TRUE, FALSE, group_ui);
        KchildlockKCM::setupUi_TUE_group(TRUE, FALSE, group_ui);
        KchildlockKCM::setupUi_WED_group(TRUE, FALSE, group_ui);
        KchildlockKCM::setupUi_THU_group(TRUE, FALSE, group_ui);
        KchildlockKCM::setupUi_FRI_group(TRUE, FALSE, group_ui);
        KchildlockKCM::setupUi_SAT_group(TRUE, FALSE, group_ui);
        KchildlockKCM::setupUi_SUN_group(TRUE, FALSE, group_ui);
     } else {
        group_ui->kcfg_sameRestrict->setDisabled(FALSE);
        group_ui->kcfg_diffRestrict->setDisabled(FALSE);
        KchildlockKCM::disableSameSettings_group(group_ui);
     };
     group_ui->kcfg_WEEKenabled->setDisabled(FALSE);
     if (group_ui->kcfg_WEEKenabled->isChecked()) {
       KchildlockKCM::setupUi_WEEK_group(FALSE, TRUE, group_ui);
     } else {
       KchildlockKCM::setupUi_WEEK_group(FALSE, FALSE, group_ui);
     }

   } else {
        KchildlockKCM::disableSameSettings_group(group_ui);
        KchildlockKCM::disableDifferentSettings_group(group_ui);
        KchildlockKCM::setupUi_DAY_group(TRUE, FALSE, group_ui);
        group_ui->kcfg_sameRestrict->setDisabled(TRUE);
        group_ui->kcfg_diffRestrict->setDisabled(TRUE);
        group_ui->kcfg_WEEKenabled->setDisabled(TRUE);
        group_ui->kcfg_WEEKmaxhr->setDisabled(TRUE);
        group_ui->kcfg_WEEKmaxmin->setDisabled(TRUE);
        KchildlockKCM::setupUi_WEEK_group(TRUE, FALSE, group_ui);
   }
   emit changed(true);
}

void KchildlockKCM::emitChanged_groupname_group(QString value)
{
   Ui_groupPage *group_ui = KchildlockKCM::current_groupPage();
   if (group_ui == 0) return;
   mycurrent_GroupSettings->setGroupnamestring(value);
   emit changed(true);
}

void KchildlockKCM::emitChanged_sameRestrict_group(bool value)
{
   Ui_groupPage *group_ui = KchildlockKCM::current_groupPage();
   if (group_ui == 0) return;
   mycurrent_GroupSettings->setSameRestrict(value);
   if (value)  {
      mycurrent_GroupSettings->setDiffRestrict(FALSE);
      KchildlockKCM::disableDifferentSettings_group(group_ui);
   };
   emit changed(true);
}


void KchildlockKCM::emitChanged_MONenabled_group(int value)
{
   Ui_groupPage *group_ui = KchildlockKCM::current_groupPage();
   if (group_ui == 0) return;
   mycurrent_GroupSettings->setMONenabled(value);
   KchildlockKCM::setupUi_MON_group(FALSE, value,group_ui);
   emit changed(true);
}


void KchildlockKCM::emitChanged_TUEenabled_group(int value)
{
   Ui_groupPage *group_ui = KchildlockKCM::current_groupPage();
   if (group_ui == 0) return;
   mycurrent_GroupSettings->setTUEenabled(value);
   KchildlockKCM::setupUi_TUE_group(FALSE, value,group_ui);
   emit changed(true);
}


void KchildlockKCM::emitChanged_WEDenabled_group(int value)
{
   Ui_groupPage *group_ui = KchildlockKCM::current_groupPage();
   if (group_ui == 0) return;
   mycurrent_GroupSettings->setWEDenabled(value);
   KchildlockKCM::setupUi_WED_group(FALSE, value,group_ui);
   emit changed(true);
}


void KchildlockKCM::emitChanged_THUenabled_group(int value)
{
   Ui_groupPage *group_ui = KchildlockKCM::current_groupPage();
   if (group_ui == 0) return;
   mycurrent_GroupSettings->setTHUenabled(value);
   KchildlockKCM::setupUi_THU_group(FALSE, value,group_ui);
   emit changed(true);
}


void KchildlockKCM::emitChanged_FRIenabled_group(int value)
{
   Ui_groupPage *group_ui = KchildlockKCM::current_groupPage();
   if (group_ui == 0) return;
   mycurrent_GroupSettings->setFRIenabled(value);
   KchildlockKCM::setupUi_FRI_group(FALSE, value,group_ui);
   emit changed(true);
}


void KchildlockKCM::emitChanged_SATenabled_group(int value)
{
   Ui_groupPage *group_ui = KchildlockKCM::current_groupPage();
   if (group_ui == 0) return;
   mycurrent_GroupSettings->setSATenabled(value);
   KchildlockKCM::setupUi_SAT_group(FALSE, value,group_ui);
   emit changed(true);
}


void KchildlockKCM::emitChanged_SUNenabled_group(int value)
{
   Ui_groupPage *group_ui = KchildlockKCM::current_groupPage();
   if (group_ui == 0) return;
   mycurrent_GroupSettings->setSUNenabled(value);
   KchildlockKCM::setupUi_SUN_group(FALSE, value,group_ui);
   emit changed(true);
}


void KchildlockKCM::emitChanged_WEEKenabled_group(int value)
{
   Ui_groupPage *group_ui = KchildlockKCM::current_groupPage();
   if (group_ui == 0) return;
   mycurrent_GroupSettings->setWEEKenabled(value);
   KchildlockKCM::setupUi_WEEK_group(FALSE, value,group_ui);
   emit changed(true);
}


void KchildlockKCM::setupUi_MON_group(bool disabled, int visible, Ui_groupPage *group_ui)
{
   if (group_ui == 0) return;
   if (!disabled) {
     if (visible) {
        group_ui->kcfg_MONgraphics->setDisabled(FALSE);
        group_ui->kcfg_MONgraphics->setVisible(TRUE);
        group_ui->kcfg_MONenabled->setDisabled(FALSE);
        group_ui->kcfg_MONfrom->setDisabled(FALSE);
        group_ui->kcfg_MONto->setDisabled(FALSE);
        group_ui->kcfg_MONmaxhr->setDisabled(FALSE);
        group_ui->kcfg_MONmaxmin->setDisabled(FALSE);
     } else {
        group_ui->kcfg_MONgraphics->setDisabled(TRUE);
        group_ui->kcfg_MONgraphics->setVisible(FALSE);
        group_ui->kcfg_MONenabled->setDisabled(FALSE);
        group_ui->kcfg_MONfrom->setDisabled(TRUE);
        group_ui->kcfg_MONto->setDisabled(TRUE);
        group_ui->kcfg_MONmaxhr->setDisabled(TRUE);
        group_ui->kcfg_MONmaxmin->setDisabled(TRUE);
     }
   } else {
        group_ui->kcfg_MONgraphics->setDisabled(TRUE);
        group_ui->kcfg_MONgraphics->setVisible(FALSE);
        group_ui->kcfg_MONenabled->setDisabled(TRUE);
        group_ui->kcfg_MONfrom->setDisabled(TRUE);
        group_ui->kcfg_MONto->setDisabled(TRUE);
        group_ui->kcfg_MONmaxhr->setDisabled(TRUE);
        group_ui->kcfg_MONmaxmin->setDisabled(TRUE);
   }
}


void KchildlockKCM::setupUi_TUE_group(bool disabled, int visible, Ui_groupPage *group_ui)
{
   if (group_ui == 0) return;
   if (!disabled) {
     if (visible) {
        group_ui->kcfg_TUEgraphics->setDisabled(FALSE);
        group_ui->kcfg_TUEgraphics->setVisible(TRUE);
        group_ui->kcfg_TUEenabled->setDisabled(FALSE);
        group_ui->kcfg_TUEfrom->setDisabled(FALSE);
        group_ui->kcfg_TUEto->setDisabled(FALSE);
        group_ui->kcfg_TUEmaxhr->setDisabled(FALSE);
        group_ui->kcfg_TUEmaxmin->setDisabled(FALSE);
     } else {
        group_ui->kcfg_TUEgraphics->setDisabled(TRUE);
        group_ui->kcfg_TUEgraphics->setVisible(FALSE);
        group_ui->kcfg_TUEenabled->setDisabled(FALSE);
        group_ui->kcfg_TUEfrom->setDisabled(TRUE);
        group_ui->kcfg_TUEto->setDisabled(TRUE);
        group_ui->kcfg_TUEmaxhr->setDisabled(TRUE);
        group_ui->kcfg_TUEmaxmin->setDisabled(TRUE);
     }
   } else {
        group_ui->kcfg_TUEgraphics->setDisabled(TRUE);
        group_ui->kcfg_TUEgraphics->setVisible(FALSE);
        group_ui->kcfg_TUEenabled->setDisabled(TRUE);
        group_ui->kcfg_TUEfrom->setDisabled(TRUE);
        group_ui->kcfg_TUEto->setDisabled(TRUE);
        group_ui->kcfg_TUEmaxhr->setDisabled(TRUE);
        group_ui->kcfg_TUEmaxmin->setDisabled(TRUE);
   }
}


void KchildlockKCM::setupUi_WED_group(bool disabled, int visible, Ui_groupPage *group_ui)
{
   if (group_ui == 0) return;
   if (!disabled) {
     if (visible) {
        group_ui->kcfg_WEDgraphics->setDisabled(FALSE);
        group_ui->kcfg_WEDgraphics->setVisible(TRUE);
        group_ui->kcfg_WEDenabled->setDisabled(FALSE);
        group_ui->kcfg_WEDfrom->setDisabled(FALSE);
        group_ui->kcfg_WEDto->setDisabled(FALSE);
        group_ui->kcfg_WEDmaxhr->setDisabled(FALSE);
        group_ui->kcfg_WEDmaxmin->setDisabled(FALSE);
     } else {
        group_ui->kcfg_WEDgraphics->setDisabled(TRUE);
        group_ui->kcfg_WEDgraphics->setVisible(FALSE);
        group_ui->kcfg_WEDenabled->setDisabled(FALSE);
        group_ui->kcfg_WEDfrom->setDisabled(TRUE);
        group_ui->kcfg_WEDto->setDisabled(TRUE);
        group_ui->kcfg_WEDmaxhr->setDisabled(TRUE);
        group_ui->kcfg_WEDmaxmin->setDisabled(TRUE);
     }
   } else {
        group_ui->kcfg_WEDgraphics->setDisabled(TRUE);
        group_ui->kcfg_WEDgraphics->setVisible(FALSE);
        group_ui->kcfg_WEDenabled->setDisabled(TRUE);
        group_ui->kcfg_WEDfrom->setDisabled(TRUE);
        group_ui->kcfg_WEDto->setDisabled(TRUE);
        group_ui->kcfg_WEDmaxhr->setDisabled(TRUE);
        group_ui->kcfg_WEDmaxmin->setDisabled(TRUE);
   }
}


void KchildlockKCM::setupUi_THU_group(bool disabled, int visible, Ui_groupPage *group_ui)
{
   if (group_ui == 0) return;
   if (!disabled) {
     if (visible) {
        group_ui->kcfg_THUgraphics->setDisabled(FALSE);
        group_ui->kcfg_THUgraphics->setVisible(TRUE);
        group_ui->kcfg_THUenabled->setDisabled(FALSE);
        group_ui->kcfg_THUfrom->setDisabled(FALSE);
        group_ui->kcfg_THUto->setDisabled(FALSE);
        group_ui->kcfg_THUmaxhr->setDisabled(FALSE);
        group_ui->kcfg_THUmaxmin->setDisabled(FALSE);
     } else {
        group_ui->kcfg_THUgraphics->setDisabled(TRUE);
        group_ui->kcfg_THUgraphics->setVisible(FALSE);
        group_ui->kcfg_THUenabled->setDisabled(FALSE);
        group_ui->kcfg_THUfrom->setDisabled(TRUE);
        group_ui->kcfg_THUto->setDisabled(TRUE);
        group_ui->kcfg_THUmaxhr->setDisabled(TRUE);
        group_ui->kcfg_THUmaxmin->setDisabled(TRUE);
     }
   } else {
        group_ui->kcfg_THUgraphics->setDisabled(TRUE);
        group_ui->kcfg_THUgraphics->setVisible(FALSE);
        group_ui->kcfg_THUenabled->setDisabled(TRUE);
        group_ui->kcfg_THUfrom->setDisabled(TRUE);
        group_ui->kcfg_THUto->setDisabled(TRUE);
        group_ui->kcfg_THUmaxhr->setDisabled(TRUE);
        group_ui->kcfg_THUmaxmin->setDisabled(TRUE);
   }
}


void KchildlockKCM::setupUi_FRI_group(bool disabled, int visible, Ui_groupPage *group_ui)
{
   if (group_ui == 0) return;
   if (!disabled) {
     if (visible) {
        group_ui->kcfg_FRIgraphics->setDisabled(FALSE);
        group_ui->kcfg_FRIgraphics->setVisible(TRUE);
        group_ui->kcfg_FRIenabled->setDisabled(FALSE);
        group_ui->kcfg_FRIfrom->setDisabled(FALSE);
        group_ui->kcfg_FRIto->setDisabled(FALSE);
        group_ui->kcfg_FRImaxhr->setDisabled(FALSE);
        group_ui->kcfg_FRImaxmin->setDisabled(FALSE);
     } else {
        group_ui->kcfg_FRIgraphics->setDisabled(TRUE);
        group_ui->kcfg_FRIgraphics->setVisible(FALSE);
        group_ui->kcfg_FRIenabled->setDisabled(FALSE);
        group_ui->kcfg_FRIfrom->setDisabled(TRUE);
        group_ui->kcfg_FRIto->setDisabled(TRUE);
        group_ui->kcfg_FRImaxhr->setDisabled(TRUE);
        group_ui->kcfg_FRImaxmin->setDisabled(TRUE);
     }
   } else {
        group_ui->kcfg_FRIgraphics->setDisabled(TRUE);
        group_ui->kcfg_FRIgraphics->setVisible(FALSE);
        group_ui->kcfg_FRIenabled->setDisabled(TRUE);
        group_ui->kcfg_FRIfrom->setDisabled(TRUE);
        group_ui->kcfg_FRIto->setDisabled(TRUE);
        group_ui->kcfg_FRImaxhr->setDisabled(TRUE);
        group_ui->kcfg_FRImaxmin->setDisabled(TRUE);
   }
}


void KchildlockKCM::setupUi_SAT_group(bool disabled, int visible, Ui_groupPage *group_ui)
{
   if (group_ui == 0) return;
   if (!disabled) {
     if (visible) {
        group_ui->kcfg_SATgraphics->setDisabled(FALSE);
        group_ui->kcfg_SATgraphics->setVisible(TRUE);
        group_ui->kcfg_SATenabled->setDisabled(FALSE);
        group_ui->kcfg_SATfrom->setDisabled(FALSE);
        group_ui->kcfg_SATto->setDisabled(FALSE);
        group_ui->kcfg_SATmaxhr->setDisabled(FALSE);
        group_ui->kcfg_SATmaxmin->setDisabled(FALSE);
     } else {
        group_ui->kcfg_SATgraphics->setDisabled(TRUE);
        group_ui->kcfg_SATgraphics->setVisible(FALSE);
        group_ui->kcfg_SATenabled->setDisabled(FALSE);
        group_ui->kcfg_SATfrom->setDisabled(TRUE);
        group_ui->kcfg_SATto->setDisabled(TRUE);
        group_ui->kcfg_SATmaxhr->setDisabled(TRUE);
        group_ui->kcfg_SATmaxmin->setDisabled(TRUE);
     }
   } else {
        group_ui->kcfg_SATgraphics->setDisabled(TRUE);
        group_ui->kcfg_SATgraphics->setVisible(FALSE);
        group_ui->kcfg_SATenabled->setDisabled(TRUE);
        group_ui->kcfg_SATfrom->setDisabled(TRUE);
        group_ui->kcfg_SATto->setDisabled(TRUE);
        group_ui->kcfg_SATmaxhr->setDisabled(TRUE);
        group_ui->kcfg_SATmaxmin->setDisabled(TRUE);
   }
}


void KchildlockKCM::setupUi_SUN_group(bool disabled, int visible, Ui_groupPage *group_ui)
{
   if (group_ui == 0) return;
   if (!disabled) {
     if (visible) {
        group_ui->kcfg_SUNgraphics->setDisabled(FALSE);
        group_ui->kcfg_SUNgraphics->setVisible(TRUE);
        group_ui->kcfg_SUNenabled->setDisabled(FALSE);
        group_ui->kcfg_SUNfrom->setDisabled(FALSE);
        group_ui->kcfg_SUNto->setDisabled(FALSE);
        group_ui->kcfg_SUNmaxhr->setDisabled(FALSE);
        group_ui->kcfg_SUNmaxmin->setDisabled(FALSE);
     } else {
        group_ui->kcfg_SUNgraphics->setDisabled(TRUE);
        group_ui->kcfg_SUNgraphics->setVisible(FALSE);
        group_ui->kcfg_SUNenabled->setDisabled(FALSE);
        group_ui->kcfg_SUNfrom->setDisabled(TRUE);
        group_ui->kcfg_SUNto->setDisabled(TRUE);
        group_ui->kcfg_SUNmaxhr->setDisabled(TRUE);
        group_ui->kcfg_SUNmaxmin->setDisabled(TRUE);
     }
   } else {
        group_ui->kcfg_SUNgraphics->setDisabled(TRUE);
        group_ui->kcfg_SUNgraphics->setVisible(FALSE);
        group_ui->kcfg_SUNenabled->setDisabled(TRUE);
        group_ui->kcfg_SUNfrom->setDisabled(TRUE);
        group_ui->kcfg_SUNto->setDisabled(TRUE);
        group_ui->kcfg_SUNmaxhr->setDisabled(TRUE);
        group_ui->kcfg_SUNmaxmin->setDisabled(TRUE);
   }
}



void KchildlockKCM::setupUi_DAY_group(bool disabled, int visible, Ui_groupPage *group_ui)
{
   if (group_ui == 0) return;
   if (!disabled) {
        group_ui->kcfg_DAYgraphics->setDisabled(FALSE);
        group_ui->kcfg_DAYgraphics->setVisible(TRUE);
        group_ui->kcfg_DAYfrom->setDisabled(FALSE);
        group_ui->kcfg_DAYto->setDisabled(FALSE);
        group_ui->kcfg_DAYmaxhr->setDisabled(FALSE);
        group_ui->kcfg_DAYmaxmin->setDisabled(FALSE);
     } else {
        group_ui->kcfg_DAYgraphics->setDisabled(TRUE);
        group_ui->kcfg_DAYgraphics->setVisible(FALSE);
        group_ui->kcfg_DAYfrom->setDisabled(TRUE);
        group_ui->kcfg_DAYto->setDisabled(TRUE);
        group_ui->kcfg_DAYmaxhr->setDisabled(TRUE);
        group_ui->kcfg_DAYmaxmin->setDisabled(TRUE);
   }
}


void KchildlockKCM::setupUi_WEEK_group(bool disabled, int visible, Ui_groupPage *group_ui)
{
   if (group_ui == 0) return;
   if (!disabled) {
     if (visible) {
        group_ui->kcfg_WEEKenabled->setDisabled(FALSE);
        group_ui->kcfg_WEEKmaxhr->setDisabled(FALSE);
        group_ui->kcfg_WEEKmaxmin->setDisabled(FALSE);
     } else {
        group_ui->kcfg_WEEKenabled->setDisabled(FALSE);
        group_ui->kcfg_WEEKmaxhr->setDisabled(TRUE);
        group_ui->kcfg_WEEKmaxmin->setDisabled(TRUE);
     }
   } else {
        group_ui->kcfg_WEEKenabled->setDisabled(TRUE);
        group_ui->kcfg_WEEKmaxhr->setDisabled(TRUE);
        group_ui->kcfg_WEEKmaxmin->setDisabled(TRUE);
   }
}




void KchildlockKCM::disableDifferentSettings_group(Ui_groupPage *group_ui)
{
//      if (group_ui == 0) return;
      KchildlockKCM::setupUi_DAY_group(FALSE, TRUE, group_ui);
      KchildlockKCM::setupUi_MON_group(TRUE, FALSE, group_ui);
      KchildlockKCM::setupUi_TUE_group(TRUE, FALSE, group_ui);
      KchildlockKCM::setupUi_WED_group(TRUE, FALSE, group_ui);
      KchildlockKCM::setupUi_THU_group(TRUE, FALSE, group_ui);
      KchildlockKCM::setupUi_FRI_group(TRUE, FALSE, group_ui);
      KchildlockKCM::setupUi_SAT_group(TRUE, FALSE, group_ui);
      KchildlockKCM::setupUi_SUN_group(TRUE, FALSE, group_ui);

};


void KchildlockKCM::emitChanged_diffRestrict_group(bool value)
{
   Ui_groupPage *group_ui = KchildlockKCM::current_groupPage();
   if (group_ui == 0) return;
   mycurrent_GroupSettings->setDiffRestrict(value);
   if (value)  {
      mycurrent_GroupSettings->setSameRestrict(FALSE);
      KchildlockKCM::disableSameSettings_group(group_ui);
   }
   emit changed(true);
};


void KchildlockKCM::disableSameSettings_group(Ui_groupPage *group_ui)
{
      if (group_ui == 0) return;

      KchildlockKCM::setupUi_DAY_group(TRUE, FALSE, group_ui);
      KchildlockKCM::setupUi_MON_group(FALSE, group_ui->kcfg_MONenabled->isChecked(), group_ui);
      KchildlockKCM::setupUi_TUE_group(FALSE, group_ui->kcfg_TUEenabled->isChecked(), group_ui);
      KchildlockKCM::setupUi_WED_group(FALSE, group_ui->kcfg_WEDenabled->isChecked(), group_ui);
      KchildlockKCM::setupUi_THU_group(FALSE, group_ui->kcfg_THUenabled->isChecked(), group_ui);
      KchildlockKCM::setupUi_FRI_group(FALSE, group_ui->kcfg_FRIenabled->isChecked(), group_ui);
      KchildlockKCM::setupUi_SAT_group(FALSE, group_ui->kcfg_SATenabled->isChecked(), group_ui);
      KchildlockKCM::setupUi_SUN_group(FALSE, group_ui->kcfg_SUNenabled->isChecked(), group_ui);
};


void KchildlockKCM::emitChanged_value_group(int value)
{
   Ui_groupPage *group_ui = KchildlockKCM::current_groupPage();
   if (group_ui == 0) return;

   mycurrent_GroupSettings->setDAYfrom(group_ui->kcfg_DAYfrom->value());
   mycurrent_GroupSettings->setDAYto(group_ui->kcfg_DAYto->value());
   mycurrent_GroupSettings->setDAYmaxhr(group_ui->kcfg_DAYmaxhr->value());
   mycurrent_GroupSettings->setDAYmaxmin(group_ui->kcfg_DAYmaxmin->value());

   mycurrent_GroupSettings->setMONenabled(group_ui->kcfg_MONenabled->isChecked());
   mycurrent_GroupSettings->setMONfrom(group_ui->kcfg_MONfrom->value());
   mycurrent_GroupSettings->setMONto(group_ui->kcfg_MONto->value());
   mycurrent_GroupSettings->setMONmaxhr(group_ui->kcfg_MONmaxhr->value());
   mycurrent_GroupSettings->setMONmaxmin(group_ui->kcfg_MONmaxmin->value());

   mycurrent_GroupSettings->setTUEenabled(group_ui->kcfg_TUEenabled->isChecked());
   mycurrent_GroupSettings->setTUEfrom(group_ui->kcfg_TUEfrom->value());
   mycurrent_GroupSettings->setTUEto(group_ui->kcfg_TUEto->value());
   mycurrent_GroupSettings->setTUEmaxhr(group_ui->kcfg_TUEmaxhr->value());
   mycurrent_GroupSettings->setTUEmaxmin(group_ui->kcfg_TUEmaxmin->value());

   mycurrent_GroupSettings->setWEDenabled(group_ui->kcfg_WEDenabled->isChecked());
   mycurrent_GroupSettings->setWEDfrom(group_ui->kcfg_WEDfrom->value());
   mycurrent_GroupSettings->setWEDto(group_ui->kcfg_WEDto->value());
   mycurrent_GroupSettings->setWEDmaxhr(group_ui->kcfg_WEDmaxhr->value());
   mycurrent_GroupSettings->setWEDmaxmin(group_ui->kcfg_WEDmaxmin->value());

   mycurrent_GroupSettings->setTHUenabled(group_ui->kcfg_THUenabled->isChecked());
   mycurrent_GroupSettings->setTHUfrom(group_ui->kcfg_THUfrom->value());
   mycurrent_GroupSettings->setTHUto(group_ui->kcfg_THUto->value());
   mycurrent_GroupSettings->setTHUmaxhr(group_ui->kcfg_THUmaxhr->value());
   mycurrent_GroupSettings->setTHUmaxmin(group_ui->kcfg_THUmaxmin->value());

   mycurrent_GroupSettings->setFRIenabled(group_ui->kcfg_FRIenabled->isChecked());
   mycurrent_GroupSettings->setFRIfrom(group_ui->kcfg_FRIfrom->value());
   mycurrent_GroupSettings->setFRIto(group_ui->kcfg_FRIto->value());
   mycurrent_GroupSettings->setFRImaxhr(group_ui->kcfg_FRImaxhr->value());
   mycurrent_GroupSettings->setFRImaxmin(group_ui->kcfg_FRImaxmin->value());

   mycurrent_GroupSettings->setSATenabled(group_ui->kcfg_SATenabled->isChecked());
   mycurrent_GroupSettings->setSATfrom(group_ui->kcfg_SATfrom->value());
   mycurrent_GroupSettings->setSATto(group_ui->kcfg_SATto->value());
   mycurrent_GroupSettings->setSATmaxhr(group_ui->kcfg_SATmaxhr->value());
   mycurrent_GroupSettings->setSATmaxmin(group_ui->kcfg_SATmaxmin->value());

   mycurrent_GroupSettings->setSUNenabled(group_ui->kcfg_SUNenabled->isChecked());
   mycurrent_GroupSettings->setSUNfrom(group_ui->kcfg_SUNfrom->value());
   mycurrent_GroupSettings->setSUNto(group_ui->kcfg_SUNto->value());
   mycurrent_GroupSettings->setSUNmaxhr(group_ui->kcfg_SUNmaxhr->value());
   mycurrent_GroupSettings->setSUNmaxmin(group_ui->kcfg_SUNmaxmin->value());

   mycurrent_GroupSettings->setWEEKenabled(group_ui->kcfg_WEEKenabled->isChecked());
   mycurrent_GroupSettings->setWEEKmaxhr(group_ui->kcfg_WEEKmaxhr->value());
   mycurrent_GroupSettings->setWEEKmaxmin(group_ui->kcfg_WEEKmaxmin->value());

   emit changed(true);
}

