/***************************************************************************
 *   Copyright (C) 2009 by Rene Landert <rene.landert@bluewin.ch>          *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <KConfigDialog>


#include "KchildlockKCM.h"
#include "kchildlock_user.h"


// User1 Slots ===========================================================================

void KchildlockKCM::emitChanged_enabled_user(int value)
{
   Ui_userPage *user_ui = KchildlockKCM::current_userPage();
   if (user_ui == 0) return;
   mycurrent_UserSettings->setEnabled(value);

   if (value) {
     if (user_ui->kcfg_sameRestrict->isChecked())  {
        user_ui->kcfg_sameRestrict->setDisabled(FALSE);
        user_ui->kcfg_diffRestrict->setDisabled(FALSE);
        KchildlockKCM::disableDifferentSettings_user(user_ui);
        KchildlockKCM::setupUi_DAY_user(FALSE, TRUE, user_ui);
        KchildlockKCM::setupUi_MON_user(TRUE, FALSE, user_ui);
        KchildlockKCM::setupUi_TUE_user(TRUE, FALSE, user_ui);
        KchildlockKCM::setupUi_WED_user(TRUE, FALSE, user_ui);
        KchildlockKCM::setupUi_THU_user(TRUE, FALSE, user_ui);
        KchildlockKCM::setupUi_FRI_user(TRUE, FALSE, user_ui);
        KchildlockKCM::setupUi_SAT_user(TRUE, FALSE, user_ui);
        KchildlockKCM::setupUi_SUN_user(TRUE, FALSE, user_ui);
     } else {
        user_ui->kcfg_sameRestrict->setDisabled(FALSE);
        user_ui->kcfg_diffRestrict->setDisabled(FALSE);
        KchildlockKCM::disableSameSettings_user(user_ui);
     };
     user_ui->kcfg_WEEKenabled->setDisabled(FALSE);
     if (user_ui->kcfg_WEEKenabled->isChecked()) {
       KchildlockKCM::setupUi_WEEK_user(FALSE, TRUE, user_ui);
     } else {
       KchildlockKCM::setupUi_WEEK_user(FALSE, FALSE, user_ui);
     }

     user_ui->kcfg_APP1enabled->setDisabled(FALSE);
     if (user_ui->kcfg_APP1enabled->isChecked()) {
       KchildlockKCM::setupUi_APP1_user(FALSE, TRUE, user_ui);
     } else {
       KchildlockKCM::setupUi_APP1_user(FALSE, FALSE, user_ui);
     }
     user_ui->kcfg_APP2enabled->setDisabled(FALSE);
     if (user_ui->kcfg_APP2enabled->isChecked()) {
       KchildlockKCM::setupUi_APP2_user(FALSE, TRUE, user_ui);
     } else {
       KchildlockKCM::setupUi_APP2_user(FALSE, FALSE, user_ui);
     }
     user_ui->kcfg_APP3enabled->setDisabled(FALSE);
     if (user_ui->kcfg_APP3enabled->isChecked()) {
       KchildlockKCM::setupUi_APP3_user(FALSE, TRUE, user_ui);
     } else {
       KchildlockKCM::setupUi_APP3_user(FALSE, FALSE, user_ui);
     }

   } else {
        KchildlockKCM::disableSameSettings_user(user_ui);
        KchildlockKCM::disableDifferentSettings_user(user_ui);
        KchildlockKCM::setupUi_DAY_user(TRUE, FALSE, user_ui);
        user_ui->kcfg_sameRestrict->setDisabled(TRUE);
        user_ui->kcfg_diffRestrict->setDisabled(TRUE);
        user_ui->kcfg_WEEKenabled->setDisabled(TRUE);
        user_ui->kcfg_WEEKmaxhr->setDisabled(TRUE);
        user_ui->kcfg_WEEKmaxmin->setDisabled(TRUE);
        KchildlockKCM::setupUi_WEEK_user(TRUE, FALSE, user_ui);
        user_ui->kcfg_APP1enabled->setDisabled(TRUE);
        user_ui->kcfg_APP2enabled->setDisabled(TRUE);
        user_ui->kcfg_APP3enabled->setDisabled(TRUE);
        KchildlockKCM::setupUi_APP1_user(TRUE, FALSE, user_ui);
        KchildlockKCM::setupUi_APP2_user(TRUE, FALSE, user_ui);
        KchildlockKCM::setupUi_APP3_user(TRUE, FALSE, user_ui);
   }
   emit changed(true);
}

void KchildlockKCM::emitChanged_username_user(QString value)
{
   Ui_userPage *user_ui = KchildlockKCM::current_userPage();
   if (user_ui == 0) return;
   mycurrent_UserSettings->setUsernamestring(value);
   emit changed(true);
}

void KchildlockKCM::emitChanged_sameRestrict_user(bool value)
{
   Ui_userPage *user_ui = KchildlockKCM::current_userPage();
   if (user_ui == 0) return;
   mycurrent_UserSettings->setSameRestrict(value);
   if (value)  {
      mycurrent_UserSettings->setDiffRestrict(FALSE);
      KchildlockKCM::disableDifferentSettings_user(user_ui);
   };
   emit changed(true);
}


void KchildlockKCM::emitChanged_MONenabled_user(int value)
{
   Ui_userPage *user_ui = KchildlockKCM::current_userPage();
   if (user_ui == 0) return;
   mycurrent_UserSettings->setMONenabled(value);
   KchildlockKCM::setupUi_MON_user(FALSE, value,user_ui);
   emit changed(true);
}


void KchildlockKCM::emitChanged_TUEenabled_user(int value)
{
   Ui_userPage *user_ui = KchildlockKCM::current_userPage();
   if (user_ui == 0) return;
   mycurrent_UserSettings->setTUEenabled(value);
   KchildlockKCM::setupUi_TUE_user(FALSE, value,user_ui);
   emit changed(true);
}


void KchildlockKCM::emitChanged_WEDenabled_user(int value)
{
   Ui_userPage *user_ui = KchildlockKCM::current_userPage();
   if (user_ui == 0) return;
   mycurrent_UserSettings->setWEDenabled(value);
   KchildlockKCM::setupUi_WED_user(FALSE, value,user_ui);
   emit changed(true);
}


void KchildlockKCM::emitChanged_THUenabled_user(int value)
{
   Ui_userPage *user_ui = KchildlockKCM::current_userPage();
   if (user_ui == 0) return;
   mycurrent_UserSettings->setTHUenabled(value);
   KchildlockKCM::setupUi_THU_user(FALSE, value,user_ui);
   emit changed(true);
}


void KchildlockKCM::emitChanged_FRIenabled_user(int value)
{
   Ui_userPage *user_ui = KchildlockKCM::current_userPage();
   if (user_ui == 0) return;
   mycurrent_UserSettings->setFRIenabled(value);
   KchildlockKCM::setupUi_FRI_user(FALSE, value,user_ui);
   emit changed(true);
}


void KchildlockKCM::emitChanged_SATenabled_user(int value)
{
   Ui_userPage *user_ui = KchildlockKCM::current_userPage();
   if (user_ui == 0) return;
   mycurrent_UserSettings->setSATenabled(value);
   KchildlockKCM::setupUi_SAT_user(FALSE, value,user_ui);
   emit changed(true);
}


void KchildlockKCM::emitChanged_SUNenabled_user(int value)
{
   Ui_userPage *user_ui = KchildlockKCM::current_userPage();
   if (user_ui == 0) return;
   mycurrent_UserSettings->setSUNenabled(value);
   KchildlockKCM::setupUi_SUN_user(FALSE, value,user_ui);
   emit changed(true);
}


void KchildlockKCM::emitChanged_WEEKenabled_user(int value)
{
   Ui_userPage *user_ui = KchildlockKCM::current_userPage();
   if (user_ui == 0) return;
   mycurrent_UserSettings->setWEEKenabled(value);
   KchildlockKCM::setupUi_WEEK_user(FALSE, value,user_ui);
   emit changed(true);
}

void KchildlockKCM::setupUi_MON_user(bool disabled, int visible, Ui_userPage *user_ui)
{
   if (user_ui == 0) return;
   if (!disabled) {
     if (visible) {
        user_ui->kcfg_MONgraphics->setDisabled(FALSE);
        user_ui->kcfg_MONgraphics->setVisible(TRUE);
        user_ui->kcfg_MONenabled->setDisabled(FALSE);
        user_ui->kcfg_MONfrom->setDisabled(FALSE);
        user_ui->kcfg_MONto->setDisabled(FALSE);
        user_ui->kcfg_MONmaxhr->setDisabled(FALSE);
        user_ui->kcfg_MONmaxmin->setDisabled(FALSE);
     } else {
        user_ui->kcfg_MONgraphics->setDisabled(TRUE);
        user_ui->kcfg_MONgraphics->setVisible(FALSE);
        user_ui->kcfg_MONenabled->setDisabled(FALSE);
        user_ui->kcfg_MONfrom->setDisabled(TRUE);
        user_ui->kcfg_MONto->setDisabled(TRUE);
        user_ui->kcfg_MONmaxhr->setDisabled(TRUE);
        user_ui->kcfg_MONmaxmin->setDisabled(TRUE);
     }
   } else {
        user_ui->kcfg_MONgraphics->setDisabled(TRUE);
        user_ui->kcfg_MONgraphics->setVisible(FALSE);
        user_ui->kcfg_MONenabled->setDisabled(TRUE);
        user_ui->kcfg_MONfrom->setDisabled(TRUE);
        user_ui->kcfg_MONto->setDisabled(TRUE);
        user_ui->kcfg_MONmaxhr->setDisabled(TRUE);
        user_ui->kcfg_MONmaxmin->setDisabled(TRUE);
   }
}


void KchildlockKCM::setupUi_TUE_user(bool disabled, int visible, Ui_userPage *user_ui)
{
   if (user_ui == 0) return;
   if (!disabled) {
     if (visible) {
        user_ui->kcfg_TUEgraphics->setDisabled(FALSE);
        user_ui->kcfg_TUEgraphics->setVisible(TRUE);
        user_ui->kcfg_TUEenabled->setDisabled(FALSE);
        user_ui->kcfg_TUEfrom->setDisabled(FALSE);
        user_ui->kcfg_TUEto->setDisabled(FALSE);
        user_ui->kcfg_TUEmaxhr->setDisabled(FALSE);
        user_ui->kcfg_TUEmaxmin->setDisabled(FALSE);
     } else {
        user_ui->kcfg_TUEgraphics->setDisabled(TRUE);
        user_ui->kcfg_TUEgraphics->setVisible(FALSE);
        user_ui->kcfg_TUEenabled->setDisabled(FALSE);
        user_ui->kcfg_TUEfrom->setDisabled(TRUE);
        user_ui->kcfg_TUEto->setDisabled(TRUE);
        user_ui->kcfg_TUEmaxhr->setDisabled(TRUE);
        user_ui->kcfg_TUEmaxmin->setDisabled(TRUE);
     }
   } else {
        user_ui->kcfg_TUEgraphics->setDisabled(TRUE);
        user_ui->kcfg_TUEgraphics->setVisible(FALSE);
        user_ui->kcfg_TUEenabled->setDisabled(TRUE);
        user_ui->kcfg_TUEfrom->setDisabled(TRUE);
        user_ui->kcfg_TUEto->setDisabled(TRUE);
        user_ui->kcfg_TUEmaxhr->setDisabled(TRUE);
        user_ui->kcfg_TUEmaxmin->setDisabled(TRUE);
   }
}


void KchildlockKCM::setupUi_WED_user(bool disabled, int visible, Ui_userPage *user_ui)
{
   if (user_ui == 0) return;
   if (!disabled) {
     if (visible) {
        user_ui->kcfg_WEDgraphics->setDisabled(FALSE);
        user_ui->kcfg_WEDgraphics->setVisible(TRUE);
        user_ui->kcfg_WEDenabled->setDisabled(FALSE);
        user_ui->kcfg_WEDfrom->setDisabled(FALSE);
        user_ui->kcfg_WEDto->setDisabled(FALSE);
        user_ui->kcfg_WEDmaxhr->setDisabled(FALSE);
        user_ui->kcfg_WEDmaxmin->setDisabled(FALSE);
     } else {
        user_ui->kcfg_WEDgraphics->setDisabled(TRUE);
        user_ui->kcfg_WEDgraphics->setVisible(FALSE);
        user_ui->kcfg_WEDenabled->setDisabled(FALSE);
        user_ui->kcfg_WEDfrom->setDisabled(TRUE);
        user_ui->kcfg_WEDto->setDisabled(TRUE);
        user_ui->kcfg_WEDmaxhr->setDisabled(TRUE);
        user_ui->kcfg_WEDmaxmin->setDisabled(TRUE);
     }
   } else {
        user_ui->kcfg_WEDgraphics->setDisabled(TRUE);
        user_ui->kcfg_WEDgraphics->setVisible(FALSE);
        user_ui->kcfg_WEDenabled->setDisabled(TRUE);
        user_ui->kcfg_WEDfrom->setDisabled(TRUE);
        user_ui->kcfg_WEDto->setDisabled(TRUE);
        user_ui->kcfg_WEDmaxhr->setDisabled(TRUE);
        user_ui->kcfg_WEDmaxmin->setDisabled(TRUE);
   }
}


void KchildlockKCM::setupUi_THU_user(bool disabled, int visible, Ui_userPage *user_ui)
{
   if (user_ui == 0) return;
   if (!disabled) {
     if (visible) {
        user_ui->kcfg_THUgraphics->setDisabled(FALSE);
        user_ui->kcfg_THUgraphics->setVisible(TRUE);
        user_ui->kcfg_THUenabled->setDisabled(FALSE);
        user_ui->kcfg_THUfrom->setDisabled(FALSE);
        user_ui->kcfg_THUto->setDisabled(FALSE);
        user_ui->kcfg_THUmaxhr->setDisabled(FALSE);
        user_ui->kcfg_THUmaxmin->setDisabled(FALSE);
     } else {
        user_ui->kcfg_THUgraphics->setDisabled(TRUE);
        user_ui->kcfg_THUgraphics->setVisible(FALSE);
        user_ui->kcfg_THUenabled->setDisabled(FALSE);
        user_ui->kcfg_THUfrom->setDisabled(TRUE);
        user_ui->kcfg_THUto->setDisabled(TRUE);
        user_ui->kcfg_THUmaxhr->setDisabled(TRUE);
        user_ui->kcfg_THUmaxmin->setDisabled(TRUE);
     }
   } else {
        user_ui->kcfg_THUgraphics->setDisabled(TRUE);
        user_ui->kcfg_THUgraphics->setVisible(FALSE);
        user_ui->kcfg_THUenabled->setDisabled(TRUE);
        user_ui->kcfg_THUfrom->setDisabled(TRUE);
        user_ui->kcfg_THUto->setDisabled(TRUE);
        user_ui->kcfg_THUmaxhr->setDisabled(TRUE);
        user_ui->kcfg_THUmaxmin->setDisabled(TRUE);
   }
}


void KchildlockKCM::setupUi_FRI_user(bool disabled, int visible, Ui_userPage *user_ui)
{
   if (user_ui == 0) return;
   if (!disabled) {
     if (visible) {
        user_ui->kcfg_FRIgraphics->setDisabled(FALSE);
        user_ui->kcfg_FRIgraphics->setVisible(TRUE);
        user_ui->kcfg_FRIenabled->setDisabled(FALSE);
        user_ui->kcfg_FRIfrom->setDisabled(FALSE);
        user_ui->kcfg_FRIto->setDisabled(FALSE);
        user_ui->kcfg_FRImaxhr->setDisabled(FALSE);
        user_ui->kcfg_FRImaxmin->setDisabled(FALSE);
     } else {
        user_ui->kcfg_FRIgraphics->setDisabled(TRUE);
        user_ui->kcfg_FRIgraphics->setVisible(FALSE);
        user_ui->kcfg_FRIenabled->setDisabled(FALSE);
        user_ui->kcfg_FRIfrom->setDisabled(TRUE);
        user_ui->kcfg_FRIto->setDisabled(TRUE);
        user_ui->kcfg_FRImaxhr->setDisabled(TRUE);
        user_ui->kcfg_FRImaxmin->setDisabled(TRUE);
     }
   } else {
        user_ui->kcfg_FRIgraphics->setDisabled(TRUE);
        user_ui->kcfg_FRIgraphics->setVisible(FALSE);
        user_ui->kcfg_FRIenabled->setDisabled(TRUE);
        user_ui->kcfg_FRIfrom->setDisabled(TRUE);
        user_ui->kcfg_FRIto->setDisabled(TRUE);
        user_ui->kcfg_FRImaxhr->setDisabled(TRUE);
        user_ui->kcfg_FRImaxmin->setDisabled(TRUE);
   }
}


void KchildlockKCM::setupUi_SAT_user(bool disabled, int visible, Ui_userPage *user_ui)
{
   if (user_ui == 0) return;
   if (!disabled) {
     if (visible) {
        user_ui->kcfg_SATgraphics->setDisabled(FALSE);
        user_ui->kcfg_SATgraphics->setVisible(TRUE);
        user_ui->kcfg_SATenabled->setDisabled(FALSE);
        user_ui->kcfg_SATfrom->setDisabled(FALSE);
        user_ui->kcfg_SATto->setDisabled(FALSE);
        user_ui->kcfg_SATmaxhr->setDisabled(FALSE);
        user_ui->kcfg_SATmaxmin->setDisabled(FALSE);
     } else {
        user_ui->kcfg_SATgraphics->setDisabled(TRUE);
        user_ui->kcfg_SATgraphics->setVisible(FALSE);
        user_ui->kcfg_SATenabled->setDisabled(FALSE);
        user_ui->kcfg_SATfrom->setDisabled(TRUE);
        user_ui->kcfg_SATto->setDisabled(TRUE);
        user_ui->kcfg_SATmaxhr->setDisabled(TRUE);
        user_ui->kcfg_SATmaxmin->setDisabled(TRUE);
     }
   } else {
        user_ui->kcfg_SATgraphics->setDisabled(TRUE);
        user_ui->kcfg_SATgraphics->setVisible(FALSE);
        user_ui->kcfg_SATenabled->setDisabled(TRUE);
        user_ui->kcfg_SATfrom->setDisabled(TRUE);
        user_ui->kcfg_SATto->setDisabled(TRUE);
        user_ui->kcfg_SATmaxhr->setDisabled(TRUE);
        user_ui->kcfg_SATmaxmin->setDisabled(TRUE);
   }
}


void KchildlockKCM::setupUi_SUN_user(bool disabled, int visible, Ui_userPage *user_ui)
{
   if (user_ui == 0) return;
   if (!disabled) {
     if (visible) {
        user_ui->kcfg_SUNgraphics->setDisabled(FALSE);
        user_ui->kcfg_SUNgraphics->setVisible(TRUE);
        user_ui->kcfg_SUNenabled->setDisabled(FALSE);
        user_ui->kcfg_SUNfrom->setDisabled(FALSE);
        user_ui->kcfg_SUNto->setDisabled(FALSE);
        user_ui->kcfg_SUNmaxhr->setDisabled(FALSE);
        user_ui->kcfg_SUNmaxmin->setDisabled(FALSE);
     } else {
        user_ui->kcfg_SUNgraphics->setDisabled(TRUE);
        user_ui->kcfg_SUNgraphics->setVisible(FALSE);
        user_ui->kcfg_SUNenabled->setDisabled(FALSE);
        user_ui->kcfg_SUNfrom->setDisabled(TRUE);
        user_ui->kcfg_SUNto->setDisabled(TRUE);
        user_ui->kcfg_SUNmaxhr->setDisabled(TRUE);
        user_ui->kcfg_SUNmaxmin->setDisabled(TRUE);
     }
   } else {
        user_ui->kcfg_SUNgraphics->setDisabled(TRUE);
        user_ui->kcfg_SUNgraphics->setVisible(FALSE);
        user_ui->kcfg_SUNenabled->setDisabled(TRUE);
        user_ui->kcfg_SUNfrom->setDisabled(TRUE);
        user_ui->kcfg_SUNto->setDisabled(TRUE);
        user_ui->kcfg_SUNmaxhr->setDisabled(TRUE);
        user_ui->kcfg_SUNmaxmin->setDisabled(TRUE);
   }
}



void KchildlockKCM::setupUi_DAY_user(bool disabled, int visible, Ui_userPage *user_ui)
{
   if (user_ui == 0) return;
   if (!disabled) {
        user_ui->kcfg_DAYgraphics->setDisabled(FALSE);
        user_ui->kcfg_DAYgraphics->setVisible(TRUE);
        user_ui->kcfg_DAYfrom->setDisabled(FALSE);
        user_ui->kcfg_DAYto->setDisabled(FALSE);
        user_ui->kcfg_DAYmaxhr->setDisabled(FALSE);
        user_ui->kcfg_DAYmaxmin->setDisabled(FALSE);
     } else {
        user_ui->kcfg_DAYgraphics->setDisabled(TRUE);
        user_ui->kcfg_DAYgraphics->setVisible(FALSE);
        user_ui->kcfg_DAYfrom->setDisabled(TRUE);
        user_ui->kcfg_DAYto->setDisabled(TRUE);
        user_ui->kcfg_DAYmaxhr->setDisabled(TRUE);
        user_ui->kcfg_DAYmaxmin->setDisabled(TRUE);
   }
}


void KchildlockKCM::setupUi_WEEK_user(bool disabled, int visible, Ui_userPage *user_ui)
{
   if (user_ui == 0) return;
   if (!disabled) {
     if (visible) {
        user_ui->kcfg_WEEKenabled->setDisabled(FALSE);
        user_ui->kcfg_WEEKmaxhr->setDisabled(FALSE);
        user_ui->kcfg_WEEKmaxmin->setDisabled(FALSE);
     } else {
        user_ui->kcfg_WEEKenabled->setDisabled(FALSE);
        user_ui->kcfg_WEEKmaxhr->setDisabled(TRUE);
        user_ui->kcfg_WEEKmaxmin->setDisabled(TRUE);
     }
   } else {
        user_ui->kcfg_WEEKenabled->setDisabled(TRUE);
        user_ui->kcfg_WEEKmaxhr->setDisabled(TRUE);
        user_ui->kcfg_WEEKmaxmin->setDisabled(TRUE);
   }
}



void KchildlockKCM::disableDifferentSettings_user(Ui_userPage *user_ui)
{
//      if (user_ui == 0) return;
      KchildlockKCM::setupUi_DAY_user(FALSE, TRUE, user_ui);
      KchildlockKCM::setupUi_MON_user(TRUE, FALSE, user_ui);
      KchildlockKCM::setupUi_TUE_user(TRUE, FALSE, user_ui);
      KchildlockKCM::setupUi_WED_user(TRUE, FALSE, user_ui);
      KchildlockKCM::setupUi_THU_user(TRUE, FALSE, user_ui);
      KchildlockKCM::setupUi_FRI_user(TRUE, FALSE, user_ui);
      KchildlockKCM::setupUi_SAT_user(TRUE, FALSE, user_ui);
      KchildlockKCM::setupUi_SUN_user(TRUE, FALSE, user_ui);

};


void KchildlockKCM::emitChanged_diffRestrict_user(bool value)
{
   Ui_userPage *user_ui = KchildlockKCM::current_userPage();
   if (user_ui == 0) return;
   mycurrent_UserSettings->setDiffRestrict(value);
   if (value)  {
      mycurrent_UserSettings->setSameRestrict(FALSE);
      KchildlockKCM::disableSameSettings_user(user_ui);
   }
   emit changed(true);
};


void KchildlockKCM::disableSameSettings_user(Ui_userPage *user_ui)
{
      if (user_ui == 0) return;

      KchildlockKCM::setupUi_DAY_user(TRUE, FALSE, user_ui);
      KchildlockKCM::setupUi_MON_user(FALSE, user_ui->kcfg_MONenabled->isChecked(), user_ui);
      KchildlockKCM::setupUi_TUE_user(FALSE, user_ui->kcfg_TUEenabled->isChecked(), user_ui);
      KchildlockKCM::setupUi_WED_user(FALSE, user_ui->kcfg_WEDenabled->isChecked(), user_ui);
      KchildlockKCM::setupUi_THU_user(FALSE, user_ui->kcfg_THUenabled->isChecked(), user_ui);
      KchildlockKCM::setupUi_FRI_user(FALSE, user_ui->kcfg_FRIenabled->isChecked(), user_ui);
      KchildlockKCM::setupUi_SAT_user(FALSE, user_ui->kcfg_SATenabled->isChecked(), user_ui);
      KchildlockKCM::setupUi_SUN_user(FALSE, user_ui->kcfg_SUNenabled->isChecked(), user_ui);

};


void KchildlockKCM::emitChanged_value_user(int value)
{
   Ui_userPage *user_ui = KchildlockKCM::current_userPage();
   if (user_ui == 0) return;

   mycurrent_UserSettings->setDAYfrom(user_ui->kcfg_DAYfrom->value());
   mycurrent_UserSettings->setDAYto(user_ui->kcfg_DAYto->value());
   mycurrent_UserSettings->setDAYmaxhr(user_ui->kcfg_DAYmaxhr->value());
   mycurrent_UserSettings->setDAYmaxmin(user_ui->kcfg_DAYmaxmin->value());

   mycurrent_UserSettings->setMONfrom(user_ui->kcfg_MONfrom->value());
   mycurrent_UserSettings->setMONto(user_ui->kcfg_MONto->value());
   mycurrent_UserSettings->setMONenabled(user_ui->kcfg_MONenabled->isChecked());
   mycurrent_UserSettings->setMONmaxhr(user_ui->kcfg_MONmaxhr->value());
   mycurrent_UserSettings->setMONmaxmin(user_ui->kcfg_MONmaxmin->value());

   mycurrent_UserSettings->setTUEfrom(user_ui->kcfg_TUEfrom->value());
   mycurrent_UserSettings->setTUEto(user_ui->kcfg_TUEto->value());
   mycurrent_UserSettings->setTUEenabled(user_ui->kcfg_TUEenabled->isChecked());
   mycurrent_UserSettings->setTUEmaxhr(user_ui->kcfg_TUEmaxhr->value());
   mycurrent_UserSettings->setTUEmaxmin(user_ui->kcfg_TUEmaxmin->value());

   mycurrent_UserSettings->setWEDfrom(user_ui->kcfg_WEDfrom->value());
   mycurrent_UserSettings->setWEDto(user_ui->kcfg_WEDto->value());
   mycurrent_UserSettings->setWEDenabled(user_ui->kcfg_WEDenabled->isChecked());
   mycurrent_UserSettings->setWEDmaxhr(user_ui->kcfg_WEDmaxhr->value());
   mycurrent_UserSettings->setWEDmaxmin(user_ui->kcfg_WEDmaxmin->value());

   mycurrent_UserSettings->setTHUfrom(user_ui->kcfg_THUfrom->value());
   mycurrent_UserSettings->setTHUto(user_ui->kcfg_THUto->value());
   mycurrent_UserSettings->setTHUenabled(user_ui->kcfg_THUenabled->isChecked());
   mycurrent_UserSettings->setTHUmaxhr(user_ui->kcfg_THUmaxhr->value());
   mycurrent_UserSettings->setTHUmaxmin(user_ui->kcfg_THUmaxmin->value());

   mycurrent_UserSettings->setFRIfrom(user_ui->kcfg_FRIfrom->value());
   mycurrent_UserSettings->setFRIto(user_ui->kcfg_FRIto->value());
   mycurrent_UserSettings->setFRIenabled(user_ui->kcfg_FRIenabled->isChecked());
   mycurrent_UserSettings->setFRImaxhr(user_ui->kcfg_FRImaxhr->value());
   mycurrent_UserSettings->setFRImaxmin(user_ui->kcfg_FRImaxmin->value());

   mycurrent_UserSettings->setSATfrom(user_ui->kcfg_SATfrom->value());
   mycurrent_UserSettings->setSATto(user_ui->kcfg_SATto->value());
   mycurrent_UserSettings->setSATenabled(user_ui->kcfg_SATenabled->isChecked());
   mycurrent_UserSettings->setSATmaxhr(user_ui->kcfg_SATmaxhr->value());
   mycurrent_UserSettings->setSATmaxmin(user_ui->kcfg_SATmaxmin->value());

   mycurrent_UserSettings->setSUNfrom(user_ui->kcfg_SUNfrom->value());
   mycurrent_UserSettings->setSUNto(user_ui->kcfg_SUNto->value());
   mycurrent_UserSettings->setSUNenabled(user_ui->kcfg_SUNenabled->isChecked());
   mycurrent_UserSettings->setSUNmaxhr(user_ui->kcfg_SUNmaxhr->value());
   mycurrent_UserSettings->setSUNmaxmin(user_ui->kcfg_SUNmaxmin->value());

   mycurrent_UserSettings->setWEEKenabled(user_ui->kcfg_WEEKenabled->isChecked());
   mycurrent_UserSettings->setWEEKmaxhr(user_ui->kcfg_WEEKmaxhr->value());
   mycurrent_UserSettings->setWEEKmaxmin(user_ui->kcfg_WEEKmaxmin->value());

   mycurrent_UserSettings->setApp1from(user_ui->kcfg_App1from->value());
   mycurrent_UserSettings->setApp1to(user_ui->kcfg_App1to->value());
   mycurrent_UserSettings->setApp1maxDhr(user_ui->kcfg_App1maxDhr->value());
   mycurrent_UserSettings->setApp1maxDmin(user_ui->kcfg_App1maxDmin->value());
   mycurrent_UserSettings->setApp1maxWhr(user_ui->kcfg_App1maxWhr->value());
   mycurrent_UserSettings->setApp1maxWmin(user_ui->kcfg_App1maxWmin->value());

   mycurrent_UserSettings->setApp2from(user_ui->kcfg_App2from->value());
   mycurrent_UserSettings->setApp2to(user_ui->kcfg_App2to->value());
   mycurrent_UserSettings->setApp2maxDhr(user_ui->kcfg_App2maxDhr->value());
   mycurrent_UserSettings->setApp2maxDmin(user_ui->kcfg_App2maxDmin->value());
   mycurrent_UserSettings->setApp2maxWhr(user_ui->kcfg_App2maxWhr->value());
   mycurrent_UserSettings->setApp2maxWmin(user_ui->kcfg_App2maxWmin->value());

   mycurrent_UserSettings->setApp3from(user_ui->kcfg_App3from->value());
   mycurrent_UserSettings->setApp3to(user_ui->kcfg_App3to->value());
   mycurrent_UserSettings->setApp3maxDhr(user_ui->kcfg_App3maxDhr->value());
   mycurrent_UserSettings->setApp3maxDmin(user_ui->kcfg_App3maxDmin->value());
   mycurrent_UserSettings->setApp3maxWhr(user_ui->kcfg_App3maxWhr->value());
   mycurrent_UserSettings->setApp3maxWmin(user_ui->kcfg_App3maxWmin->value());

   emit changed(true);
}
