/***************************************************************************
 *   Copyright (C) 2009 by Rene Landert <rene.landert@bluewin.ch>          *
 *                                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <KConfigDialog>


#include "KchildlockKCM.h"
#include "kchildlock_user.h"


// User1 Slots ===========================================================================


void KchildlockKCM::emitChanged_APPenabled_user(int value)
{
   Ui_userPage *user_ui = KchildlockKCM::current_userPage();
   if (user_ui == 0) return;
   mycurrent_UserSettings->setAPP1enabled(user_ui->kcfg_APP1enabled->isChecked());
   mycurrent_UserSettings->setAPP2enabled(user_ui->kcfg_APP2enabled->isChecked());
   mycurrent_UserSettings->setAPP3enabled(user_ui->kcfg_APP3enabled->isChecked());
   
   if (user_ui->kcfg_APP1enabled->isChecked()) {
      KchildlockKCM::setupUi_APP1_user(FALSE, TRUE, user_ui);
   } else {
      KchildlockKCM::setupUi_APP1_user(FALSE, FALSE, user_ui);
   }
   if (user_ui->kcfg_APP2enabled->isChecked()) {
      KchildlockKCM::setupUi_APP2_user(FALSE, TRUE, user_ui);
   } else {
      KchildlockKCM::setupUi_APP2_user(FALSE, FALSE, user_ui);
   }
   if (user_ui->kcfg_APP3enabled->isChecked()) {
      KchildlockKCM::setupUi_APP3_user(FALSE, TRUE, user_ui);
   } else {
      KchildlockKCM::setupUi_APP3_user(FALSE, FALSE, user_ui);
   }
   emit changed(true);
}



void KchildlockKCM::setupUi_APP1_user(bool disabled, int visible, Ui_userPage *user_ui)
{
   if (user_ui == 0) return;
   if (!disabled) {
     if (visible) {
        user_ui->kcfg_App1graphics->setDisabled(FALSE);
        user_ui->kcfg_App1graphics->setVisible(TRUE);
        user_ui->kcfg_AppName1->setDisabled(FALSE);
        user_ui->kcfg_App1maxDhr->setDisabled(FALSE);
        user_ui->kcfg_App1maxDmin->setDisabled(FALSE);
        user_ui->kcfg_App1maxWhr->setDisabled(FALSE);
        user_ui->kcfg_App1maxWmin->setDisabled(FALSE);
     } else {
        user_ui->kcfg_App1graphics->setDisabled(TRUE);
        user_ui->kcfg_App1graphics->setVisible(FALSE);
        user_ui->kcfg_AppName1->setDisabled(TRUE);
        user_ui->kcfg_App1maxDhr->setDisabled(TRUE);
        user_ui->kcfg_App1maxDmin->setDisabled(TRUE);
        user_ui->kcfg_App1maxWhr->setDisabled(TRUE);
        user_ui->kcfg_App1maxWmin->setDisabled(TRUE);
     }
   } else {
        user_ui->kcfg_App1graphics->setDisabled(TRUE);
        user_ui->kcfg_App1graphics->setVisible(FALSE);
        user_ui->kcfg_AppName1->setDisabled(TRUE);
        user_ui->kcfg_App1maxDhr->setDisabled(TRUE);
        user_ui->kcfg_App1maxDmin->setDisabled(TRUE);
        user_ui->kcfg_App1maxWhr->setDisabled(TRUE);
        user_ui->kcfg_App1maxWmin->setDisabled(TRUE);
   }
}



void KchildlockKCM::setupUi_APP2_user(bool disabled, int visible, Ui_userPage *user_ui)
{
   if (user_ui == 0) return;
   if (!disabled) {
     if (visible) {
        user_ui->kcfg_App2graphics->setDisabled(FALSE);
        user_ui->kcfg_App2graphics->setVisible(TRUE);
        user_ui->kcfg_AppName2->setDisabled(FALSE);
        user_ui->kcfg_App2maxDhr->setDisabled(FALSE);
        user_ui->kcfg_App2maxDmin->setDisabled(FALSE);
        user_ui->kcfg_App2maxWhr->setDisabled(FALSE);
        user_ui->kcfg_App2maxWmin->setDisabled(FALSE);
     } else {
        user_ui->kcfg_App2graphics->setDisabled(TRUE);
        user_ui->kcfg_App2graphics->setVisible(FALSE);
        user_ui->kcfg_AppName2->setDisabled(TRUE);
        user_ui->kcfg_App2maxDhr->setDisabled(TRUE);
        user_ui->kcfg_App2maxDmin->setDisabled(TRUE);
        user_ui->kcfg_App2maxWhr->setDisabled(TRUE);
        user_ui->kcfg_App2maxWmin->setDisabled(TRUE);
     }
   } else {
        user_ui->kcfg_App2graphics->setDisabled(TRUE);
        user_ui->kcfg_App2graphics->setVisible(FALSE);
        user_ui->kcfg_AppName2->setDisabled(TRUE);
        user_ui->kcfg_App2maxDhr->setDisabled(TRUE);
        user_ui->kcfg_App2maxDmin->setDisabled(TRUE);
        user_ui->kcfg_App2maxWhr->setDisabled(TRUE);
        user_ui->kcfg_App2maxWmin->setDisabled(TRUE);
   }
}



void KchildlockKCM::setupUi_APP3_user(bool disabled, int visible, Ui_userPage *user_ui)
{
   if (user_ui == 0) return;
   if (!disabled) {
     if (visible) {
        user_ui->kcfg_App3graphics->setDisabled(FALSE);
        user_ui->kcfg_App3graphics->setVisible(TRUE);
        user_ui->kcfg_AppName3->setDisabled(FALSE);
        user_ui->kcfg_App3maxDhr->setDisabled(FALSE);
        user_ui->kcfg_App3maxDmin->setDisabled(FALSE);
        user_ui->kcfg_App3maxWhr->setDisabled(FALSE);
        user_ui->kcfg_App3maxWmin->setDisabled(FALSE);
     } else {
        user_ui->kcfg_App3graphics->setDisabled(TRUE);
        user_ui->kcfg_App3graphics->setVisible(FALSE);
        user_ui->kcfg_AppName3->setDisabled(TRUE);
        user_ui->kcfg_App3maxDhr->setDisabled(TRUE);
        user_ui->kcfg_App3maxDmin->setDisabled(TRUE);
        user_ui->kcfg_App3maxWhr->setDisabled(TRUE);
        user_ui->kcfg_App3maxWmin->setDisabled(TRUE);
     }
   } else {
        user_ui->kcfg_App3graphics->setDisabled(TRUE);
        user_ui->kcfg_App3graphics->setVisible(FALSE);
        user_ui->kcfg_AppName3->setDisabled(TRUE);
        user_ui->kcfg_App3maxDhr->setDisabled(TRUE);
        user_ui->kcfg_App3maxDmin->setDisabled(TRUE);
        user_ui->kcfg_App3maxWhr->setDisabled(TRUE);
        user_ui->kcfg_App3maxWmin->setDisabled(TRUE);
   }
}




void KchildlockKCM::emitChanged_appname_user(QString value)
{
   Ui_userPage *user_ui = KchildlockKCM::current_userPage();
   if (user_ui == 0) return;

   mycurrent_UserSettings->setAppName1(user_ui->kcfg_AppName1->text().toAscii().constData());
   mycurrent_UserSettings->setAppName2(user_ui->kcfg_AppName2->text().toAscii().constData());
   mycurrent_UserSettings->setAppName3(user_ui->kcfg_AppName3->text().toAscii().constData());
   emit changed(true);
}
